;;;; Copyright 2005 Juri Pakaste
;;;; 
;;;; This file is part of Lukutoukka.
;;;; 
;;;; Lukutoukka is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; Lukutoukka is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with Lukutoukka; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(define-module (lukutoukkalib ui error)
  #:use-module (lukutoukkalib utils)
  #:use-module (gnome gtk)
  #:use-module (gnome glade)
  #:export (show-error-dialog))

(define +error-window-name+ "error_dialog")
(define +error-label-name+ "error_message_label")

(define (show-error-dialog message)
  (let* ((xml (glade-xml-new (find-data-file +glade-error-window-file+)))
         (dialog (get-widget xml +error-window-name+))
         (label (get-widget xml +error-label-name+)))
    (set-text label message)
    (connect dialog 'response 
             (lambda (dialog response) (destroy dialog)))
    (show-all dialog)))

