;;;; Copyright 2005 Juri Pakaste
;;;; 
;;;; This file is part of Lukutoukka.
;;;; 
;;;; Lukutoukka is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; Lukutoukka is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with Lukutoukka; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(define-module (file-read-test)
  #:use-module (lukutoukkalib file)
  #:use-module (lukutoukkalib binaryformat)
  #:use-module (lukutoukkalib srfi srfi-56)
  #:use-module (unit-test)
  #:use-module (oop goops)
  #:export (create-test-suite))

(define-class <file-read-test> (<test-case>))

(define-method (test-no-words-file (test-case <file-read-test>))
  (let* ((input-string-port (open-input-string 
                             (string-append 
                              "lukutoukka"
                              (with-output-to-string
                               (lambda ()
                                 ((create-packer "SQ" 'big-endian) 0 20)))
                              (with-output-to-string
                               (lambda ()
                                 (display #()))))))
         (reader (create-file-reader input-string-port)))
    (assert-equal (read-next-word reader) #f)))

(define-method (test-one-word-file (test-case <file-read-test>))
  (let* ((input-string-port (open-input-string 
                             (string-append 
                              "lukutoukka"
                              (with-output-to-string
                               (lambda ()
                                 ((create-packer "SQ" 'big-endian) 0 26)))
                              "\"kala\""
                              (with-output-to-string
                               (lambda ()
                                 (display #(20)))))))
         (reader (create-file-reader input-string-port)))
    (assert-equal "kala" (read-next-word reader))
    (assert-equal #f (read-next-word reader))))

(define (create-test-suite) 
  (let ((suite (make <test-suite> #:name "file-read-test-suite")))
    (add suite (make <file-read-test>))
    suite))
