;;;; Copyright 2005 Juri Pakaste
;;;; 
;;;; This file is part of Lukutoukka.
;;;; 
;;;; Lukutoukka is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; Lukutoukka is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with Lukutoukka; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(define-module (lukutoukkalib book)
  #:use-module (oop goops)
  #:export (<book> direction get-next-word position number-of-words book-name))

(define-class <book> ()
  (words #:init-keyword #:words #:getter words)
  (direction #:init-value 'forward #:accessor direction)
  (position #:init-value -1 #:accessor position)
  (book-name #:init-keyword #:book-name #:accessor book-name))

(define-method (get-next-word (book <book>))
  (let ((word-index (min (- (vector-length (words book)) 1)
                         (max 0 ((if (eq? (direction book) 'forward) + -) 
                                 (position book)
                                 1)))))
    (set! (position book) word-index)
    (vector-ref (words book) word-index)))

(define-method (number-of-words (book <book>))
  (vector-length (words book)))
