;;;; Copyright 2005 Juri Pakaste
;;;; 
;;;; This file is part of Lukutoukka.
;;;; 
;;;; Lukutoukka is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; Lukutoukka is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with Lukutoukka; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(define-module (pause-add-test)
  #:use-module (lukutoukkalib parsers defs)
  #:use-module (lukutoukkalib parsers common)
  #:use-module (unit-test)
  #:use-module (oop goops)
  #:export (create-test-suite))

(define-class <pause-add-test> (<test-case>))

(define-method (test-single-word-end (test-case <pause-add-test>))
  (assert-equal '(("foo." 2)) (add-pauses (list "foo."))))

(define-method (test-two-words (test-case <pause-add-test>))
  (assert-equal '(("foo." 2) "bar") (add-pauses (list "foo." "bar"))))

(define-method (test-single-period (test-case <pause-add-test>))
  (assert-equal '(("." 2)) (add-pauses (list "."))))

; got (pause (1.6)) pauses here, thanks to a missing dot in a
; supposedly dotted pair
(define-method (test-multiple-dashes (test-case <pause-add-test>))
  (assert-equal '(("--" 1.6)) (add-pauses (list "--"))))

(define (create-test-suite) 
  (let ((suite (make <test-suite> #:name "pause-add-test-suite")))
    (add suite (make <pause-add-test>))
    suite))

