#!/usr/bin/guile -s
!#

;;;; Copyright 2005 Juri Pakaste
;;;; 
;;;; This file is part of Lukutoukka.
;;;; 
;;;; Lukutoukka is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; Lukutoukka is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with Lukutoukka; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(set! %load-path (cons "../src" %load-path))

; use unit-test from guile-lib
(use-modules ((plain-parser-test)
              :renamer (symbol-prefix-proc 'plain:))
             ((pause-add-test)
              :renamer (symbol-prefix-proc 'pause:))
             ((binaryformat-test)
              :renamer (symbol-prefix-proc 'binaryformat:))
             ((file-write-test)
              :renamer (symbol-prefix-proc 'file-write:))
             ((file-read-test)
              :renamer (symbol-prefix-proc 'file-read:))
             ((file-write-read-test)
              :renamer (symbol-prefix-proc 'file-write-read:))
             ((bookmarks-test)
              :renamer (symbol-prefix-proc 'bookmarks:))
             (oop goops)
             (unit-test))

(define (run-tests)
  (let ((suite (make <test-suite>))
        (result (make <test-result>)))
    (add suite (plain:create-test-suite))
    (add suite (pause:create-test-suite))
    (add suite (binaryformat:create-test-suite))
    (add suite (file-write:create-test-suite))
    (add suite (file-read:create-test-suite))
    (add suite (file-write-read:create-test-suite))
    (add suite (bookmarks:create-test-suite))
    (run suite result)
    result))

(exit-with-summary (run-tests))

